function downloadFile(url, name, progressNode) {
	return new Promise(function(resolve, reject) {
		var filePath = "_downloads/" + name;
		var options = {
			filename: filePath
		};
		var dtask = plus.downloader.createDownload(url, options,
			function(d, status) {
				// 下载完成
				if(status == 200 && d.state == 4) {
					console.log("文件下载成功: " + d.filename);
					resolve(filePath);
				} else {
					console.log("文件下载失败: " + status);
				}
			});
		dtask.addEventListener("statechanged", function(download, status) {
			switch(download.state) {
				case 3:
					var percent = download.downloadedSize / download.totalSize * 100;
					progressNode.innerHTML = parseInt(percent) + "%";
			}
		});
		dtask.start();
	});
}

function deleteFile(filePath) {
	return new Promise(function(resolve, reject) {
		plus.io.resolveLocalFileSystemURL(filePath, function(entry) {
			entry.remove(function() {
				console.log('删除成功:' + filePath);
				resolve();
			});
		});
	});
}

function writeFile(url, name, progressNode) {
	var filePath = "_downloads/" + name;
	return new Promise(function(resolve, reject) {
		$.ajax({
			type: "get",
			url: url,
			async: true,
			beforeSend: function(xhr) {
				xhr.overrideMimeType("text/csv;charset=gb2312");
			},
			success: function(data) {
				plus.io.resolveLocalFileSystemURL("_downloads/", function(entry) {
					entry.getFile(name, {
						create: true
					}, function(entry) {
						entry.createWriter(function(writer) {
							writer.onwrite = function() {
								console.log('写文件成功');
								resolve(filePath);
							}
							writer.onprogress = function(e) {
								console.log(JSON.stringify(e));
							}
							writer.seek(0);
							writer.write(data);
						}, function(file) {
							console.log("写入文件出错");
						});
					}, function(file) {
						console.log("创建文件出错");
					});
				}, function(e) {
					console.log("获取文件路径出错: " + e.message);
				});
			}
		});
	});
}

function readFile(filePath) {
	console.log(filePath);
	return new Promise(function(resolve, reject) {
		plus.io.resolveLocalFileSystemURL(filePath, function(entry) {
				// 可通过entry对象操作test.html文件 
				entry.file(function(file) {
					var fileReader = new plus.io.FileReader();
					console.log("getFile:" + JSON.stringify(file));
					fileReader.readAsText(file);
					fileReader.onloadend = function(evt) {
						resolve(evt.target.result);
					}
					fileReader.onerror = function(e) {
						console.log(JSON.stringify(e));
					}
					console.log(file.size + '--' + file.name);
				});
			},
			function(e) {
				$.ajax({
					type: "get",
					url: filePath,
					async: true,
					beforeSend: function(xhr) {
						xhr.overrideMimeType("text/csv;charset=gb2312");
					},
					success: function(data) {
						resolve(data);
					}
				});
			});
	});
}